#pragma once

#include <commctrl.h>

#include <string>
#include <list>

#include "BeckyApi.h"
#include "AddressInfo.h"
#include "ChkWordList.h"
#include "BkBsfilWrapper.h"
#include "BkBsfilProfile.h"

////////////////////////////////////////////////////////////////////////
// ݒ_CAOւ̃p[^
////////////////////////////////////////////////////////////////////////

class SettingDialogParam {
public:
	// Becky! API ւ̎Q
	CBeckyAPI* pbka;
	// Becky! ̃f[^tH_
	std::string bkaDataFolder;
	// vOC̃f[^tH_
	std::string dataFolder;
	// bsfilter ̐ݒt@C
	std::string bsfilterConfig;
	// bsfilter ̃f[^x[XtH_
	std::string dbFolder;
	// BkBsfilWrapper ̐ݒ
	BkBsfilProfile bkProfile;
	// ReLXgj[̈ʒu̐ݒ
	ContextMenuProfile ctxMenuProfile;
	// bsfilter XNvgł̎ŝ߂̐ݒ
	ExecBsfilterScriptProfile execBsScriptProfile;
	// NG [h̐ݒ
	NgWordProfile ngWordProfile;
	// OK [h̐ݒ
	OkWordProfile okWordProfile;

	// zCgXg̐ݒ(p)
	BkBsfilWhiteListProfileEnv bkWhiteListProfileEnv;
	// zCgXg
	WhiteList whiteList;

	// NG [h̐ݒ(p)
	NgWordProfileEnv ngWordProfileEnv;
	// NG [hꗗ
	ChkWordList ngWordList;

	// OK [h̐ݒ(p)
	OkWordProfileEnv okWordProfileEnv;
	// OK [hꗗ
	ChkWordList okWordList;

	// f[^x[X̔rp
	CRITICAL_SECTION* pcsDatabase;
};

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CBkBsfilSettingDialogProc {
public:
	// RXgN^
	CBkBsfilSettingDialogProc(SettingDialogParam& param);

public:
	// BkBsfilWrapper ̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// bsfilter f[^x[XobNAbv
	bool BackupBsfilterResource(char* backupFilepath, std::list<std::string>& fileList);
	// bsfilter f[^x[XXgA
	bool RestoreBsfilterResource(const char* backupFilepath, std::list<std::string>& fileList);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
};

////////////////////////////////////////////////////////////////////////
// ̑̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class COtherSettingDialogProc {
public:
	// RXgN^
	COtherSettingDialogProc(SettingDialogParam& param);

public:
	// ̑̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
};

////////////////////////////////////////////////////////////////////////
// zCgXg̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CWhiteListDialogProc {
public:
	// RXgN^
	CWhiteListDialogProc(SettingDialogParam& param);
	// fXgN^
	virtual ~CWhiteListDialogProc();

public:
	// zCgXg̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// [[AhXꗗɒǉ
	void AddMail(HWND hWnd, const char* email, const char* note);
	// [AhXꗗ̃[XV
	void UpdateMail(HWND hWnd, const char* email, const char* note);
	// [AhXꗗ烁[폜
	void DeleteMail(HWND hWnd);
	// [AhXꗗ̃^Cgɖݒ肷
	void SetAddrListSortArrow(HWND listCtrl);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
	// AhXꗗpC[WXg
	HIMAGELIST m_hImgList;
	// \[g̖̃rbg}bv
	HBITMAP m_bmUpArrow;
	HBITMAP m_bmDownArrow;
};

////////////////////////////////////////////////////////////////////////
// CHK [h̐ݒs_CAOvV[W̋@\(OK/NG ̃x[X)
////////////////////////////////////////////////////////////////////////

class CChkWordListDialogProc {
public:
	// RXgN^
	CChkWordListDialogProc(SettingDialogParam& param);
	// fXgN^
	virtual ~CChkWordListDialogProc();

public:
	// CHK [h̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// CHK [h CHK [hꗗɒǉ
	void AddChkWord(HWND hWnd, const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase);
	// CHK [hꗗ CHK [hXV
	void UpdateChkWord(HWND hWnd, const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase);
	// CHK [hꗗ CHK [h폜
	void DeleteChkWord(HWND hWnd);
	// CHK [hꗗ̃^Cgɖݒ肷
	void SetChkWordListSortArrow(HWND listCtrl);

protected:
	// CHK [hgp ID
	virtual int GetUseChkWordCtrlId() = 0;

	// CHK [hꗗ ID
	virtual int GetChkWordListCtrlId() = 0;

	// ׂăWI{^ ID
	virtual int GetChkAllCtrlId() = 0;
	// WI{^ ID
	virtual int GetChkSubjectCtrlId() = 0;
	// olWI{^ ID
	virtual int GetChkFromnameCtrlId() = 0;

	// CHK [h ID
	virtual int GetChkWordCtrlId() = 0;

	// K\g̃`FbN{bNX ID
	virtual int GetIsRegexCtrlId() = 0;
	// 召ʂ̃`FbN{bNX ID
	virtual int GetIsCaseCtrlId() = 0;

	// eXgΏە ID
	virtual int GetChkWordTestTargetCtrlId() = 0;
	// eXg{^ ID
	virtual int GetChkWordTestCtrlId() = 0;

	// uΏہvڕ̃\[X ID
	virtual int GetChkWordListWordTypeTitleResId() = 0;
	// u[hvڕ̃\[X ID
	virtual int GetChkWordListChkWordTitleResId() = 0;
	// uK\vڕ̃\[X ID
	virtual int GetChkWordListIsRegexTitleResId() = 0;
	// u召ʁvڕ̃\[X ID
	virtual int GetChkWordListIsCaseTitleResId() = 0;

	// ǉ{^ ID
	virtual int GetAddChkWordCtrlId() = 0;
	// XV{^ ID
	virtual int GetUpdateChkWordCtrlId() = 0;
	// 폜{^ ID
	virtual int GetDelChkWordCtrlId() = 0;
	// C|[g{^ ID
	virtual int GetImportChkWordListCtrlId() = 0;
	// GNX|[g{^ ID
	virtual int GetExportChkWordListCtrlId() = 0;

	// CHK [hė~|̃bZ[W̃\[X ID
	virtual int GetEnterChkWordMsgResId() = 0;
	// eXgɃ}b`|̃bZ[W̃\[X ID
	virtual int GetTestMatchMsgResId() = 0;
	// eXgɃ}b`Ȃ|̃bZ[W̃\[X ID
	virtual int GetTestNotMatchMsgResId() = 0;
	// eXgɃ}b`G[o|̃bZ[W̃\[X ID
	virtual int GetTestNotMatchAndErrorMsgResId() = 0;
	// łɓo^Ă̂ōXV邩̃bZ[W̃\[X ID
	virtual int GetWordAlreadyRegisterdOrUpdateMsgResId() = 0;
	// o^ĂȂ̂Œǉ邩̃bZ[W̃\[X ID
	virtual int GetWordNotRegisterdOrAddMsgResId() = 0;
	// 폜ɈꗗIĂȂꍇ̃bZ[W̃\[X ID
	virtual int GetChooseInTheListToDeleteChkWordMsgResId() = 0;
	// C|[g܂bZ[W̃\[X ID
	virtual int GetCompleteImportChkWordListMsgResId() = 0;
	// GNX|[g܂bZ[W̃\[X ID
	virtual int GetCompleteExportChkWordListMsgResId() = 0;

	// C|[gtB^̃\[X ID
	virtual int GetImportChkWordListFileFilterResId() = 0;
	// C|[g^Cg̃\[X ID
	virtual int GetImportChkWordListTitleResId() = 0;

	// GNX|[gtB^̃\[X ID
	virtual int GetExportChkWordListFileFilterResId() = 0;
	// GNX|[g^Cg̃\[X ID
	virtual int GetExportChkWordListTitleResId() = 0;
	// GNX|[gftHggq̃\[X ID
	virtual int GetExportChkWordListDefExtResId() = 0;

	// K\A召ʂ̃`FbN\̃\[X ID
	virtual int GetChkWordListCheckMarkResId() = 0;

	// C|[g̃tH[}bg
	virtual char* GetImportChkWordListFormat() = 0;
	// GNX|[g̃t@CtH[}bg
	virtual char* GetExportChkWordListFormat() = 0;

	// ݒԂ
	virtual ChkWordProfile& GetChkWordProfile() = 0;
	// ݒ(p)Ԃ
	virtual ChkWordProfileEnv& GetChkWordProfileEnv() = 0;
	// CHK [hꗗԂ
	virtual ChkWordList& GetChkWordList() = 0;

protected:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;

private:
	// _CAÕLvV
	char m_dlgCaption[1024];
	// \[g̖̃rbg}bv
	HBITMAP m_bmUpArrow;
	HBITMAP m_bmDownArrow;
};

////////////////////////////////////////////////////////////////////////
// NG [h̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CNgWordListDialogProc : public CChkWordListDialogProc
{
public:
	// RXgN^
	CNgWordListDialogProc(SettingDialogParam& param);

protected:
	// CHK [hgp ID
	int GetUseChkWordCtrlId();

	// CHK [hꗗ ID
	int GetChkWordListCtrlId();

	// ׂăWI{^ ID
	int GetChkAllCtrlId();
	// WI{^ ID
	int GetChkSubjectCtrlId();
	// olWI{^ ID
	int GetChkFromnameCtrlId();

	// CHK [h ID
	int GetChkWordCtrlId();

	// K\g̃`FbN{bNX ID
	int GetIsRegexCtrlId();
	// 召ʂ̃`FbN{bNX ID
	int GetIsCaseCtrlId();

	// eXgΏە ID
	int GetChkWordTestTargetCtrlId();
	// eXg{^ ID
	int GetChkWordTestCtrlId();

	// uΏہvڕ̃\[X ID
	int GetChkWordListWordTypeTitleResId();
	// u[hvڕ̃\[X ID
	int GetChkWordListChkWordTitleResId();
	// uK\vڕ̃\[X ID
	int GetChkWordListIsRegexTitleResId();
	// u召ʁvڕ̃\[X ID
	int GetChkWordListIsCaseTitleResId();

	// ǉ{^ ID
	int GetAddChkWordCtrlId();
	// XV{^ ID
	int GetUpdateChkWordCtrlId();
	// 폜{^ ID
	int GetDelChkWordCtrlId();
	// C|[g{^ ID
	int GetImportChkWordListCtrlId();
	// GNX|[g{^ ID
	int GetExportChkWordListCtrlId();

	// CHK [hė~|̃bZ[W̃\[X ID
	int GetEnterChkWordMsgResId();
	// eXgɃ}b`|̃bZ[W̃\[X ID
	int GetTestMatchMsgResId();
	// eXgɃ}b`Ȃ|̃bZ[W̃\[X ID
	int GetTestNotMatchMsgResId();
	// eXgɃ}b`G[o|̃bZ[W̃\[X ID
	int GetTestNotMatchAndErrorMsgResId();
	// łɓo^Ă̂ōXV邩̃bZ[W̃\[X ID
	int GetWordAlreadyRegisterdOrUpdateMsgResId();
	// o^ĂȂ̂Œǉ邩̃bZ[W̃\[X ID
	int GetWordNotRegisterdOrAddMsgResId();
	// 폜ɈꗗIĂȂꍇ̃bZ[W̃\[X ID
	int GetChooseInTheListToDeleteChkWordMsgResId();
	// C|[g܂bZ[W̃\[X ID
	int GetCompleteImportChkWordListMsgResId();
	// GNX|[g܂bZ[W̃\[X ID
	int GetCompleteExportChkWordListMsgResId();

	// C|[gtB^̃\[X ID
	int GetImportChkWordListFileFilterResId();
	// C|[g^Cg̃\[X ID
	int GetImportChkWordListTitleResId();

	// GNX|[gtB^̃\[X ID
	int GetExportChkWordListFileFilterResId();
	// GNX|[g^Cg̃\[X ID
	int GetExportChkWordListTitleResId();
	// GNX|[gftHggq̃\[X ID
	int GetExportChkWordListDefExtResId();

	// K\A召ʂ̃`FbN\̃\[X ID
	int GetChkWordListCheckMarkResId();

	// C|[g̃tH[}bg
	char* GetImportChkWordListFormat();
	// GNX|[g̃t@CtH[}bg
	char* GetExportChkWordListFormat();

	// ݒԂ
	ChkWordProfile& GetChkWordProfile();
	// ݒ(p)Ԃ
	ChkWordProfileEnv& GetChkWordProfileEnv();
	// CHK [hꗗԂ
	ChkWordList& GetChkWordList();
};

////////////////////////////////////////////////////////////////////////
// OK [h̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class COkWordListDialogProc : public CChkWordListDialogProc
{
public:
	// RXgN^
	COkWordListDialogProc(SettingDialogParam& param);

protected:
	// CHK [hgp ID
	int GetUseChkWordCtrlId();

	// CHK [hꗗ ID
	int GetChkWordListCtrlId();

	// ׂăWI{^ ID
	int GetChkAllCtrlId();
	// WI{^ ID
	int GetChkSubjectCtrlId();
	// olWI{^ ID
	int GetChkFromnameCtrlId();

	// CHK [h ID
	int GetChkWordCtrlId();

	// K\g̃`FbN{bNX ID
	int GetIsRegexCtrlId();
	// 召ʂ̃`FbN{bNX ID
	int GetIsCaseCtrlId();

	// eXgΏە ID
	int GetChkWordTestTargetCtrlId();
	// eXg{^ ID
	int GetChkWordTestCtrlId();

	// uΏہvڕ̃\[X ID
	int GetChkWordListWordTypeTitleResId();
	// u[hvڕ̃\[X ID
	int GetChkWordListChkWordTitleResId();
	// uK\vڕ̃\[X ID
	int GetChkWordListIsRegexTitleResId();
	// u召ʁvڕ̃\[X ID
	int GetChkWordListIsCaseTitleResId();

	// ǉ{^ ID
	int GetAddChkWordCtrlId();
	// XV{^ ID
	int GetUpdateChkWordCtrlId();
	// 폜{^ ID
	int GetDelChkWordCtrlId();
	// C|[g{^ ID
	int GetImportChkWordListCtrlId();
	// GNX|[g{^ ID
	int GetExportChkWordListCtrlId();

	// CHK [hė~|̃bZ[W̃\[X ID
	int GetEnterChkWordMsgResId();
	// eXgɃ}b`|̃bZ[W̃\[X ID
	int GetTestMatchMsgResId();
	// eXgɃ}b`Ȃ|̃bZ[W̃\[X ID
	int GetTestNotMatchMsgResId();
	// eXgɃ}b`G[o|̃bZ[W̃\[X ID
	int GetTestNotMatchAndErrorMsgResId();
	// łɓo^Ă̂ōXV邩̃bZ[W̃\[X ID
	int GetWordAlreadyRegisterdOrUpdateMsgResId();
	// o^ĂȂ̂Œǉ邩̃bZ[W̃\[X ID
	int GetWordNotRegisterdOrAddMsgResId();
	// 폜ɈꗗIĂȂꍇ̃bZ[W̃\[X ID
	int GetChooseInTheListToDeleteChkWordMsgResId();
	// C|[g܂bZ[W̃\[X ID
	int GetCompleteImportChkWordListMsgResId();
	// GNX|[g܂bZ[W̃\[X ID
	int GetCompleteExportChkWordListMsgResId();

	// C|[gtB^̃\[X ID
	int GetImportChkWordListFileFilterResId();
	// C|[g^Cg̃\[X ID
	int GetImportChkWordListTitleResId();

	// GNX|[gtB^̃\[X ID
	int GetExportChkWordListFileFilterResId();
	// GNX|[g^Cg̃\[X ID
	int GetExportChkWordListTitleResId();
	// GNX|[gftHggq̃\[X ID
	int GetExportChkWordListDefExtResId();

	// K\A召ʂ̃`FbN\̃\[X ID
	int GetChkWordListCheckMarkResId();

	// C|[g̃tH[}bg
	char* GetImportChkWordListFormat();
	// GNX|[g̃t@CtH[}bg
	char* GetExportChkWordListFormat();

	// ݒԂ
	ChkWordProfile& GetChkWordProfile();
	// ݒ(p)Ԃ
	ChkWordProfileEnv& GetChkWordProfileEnv();
	// CHK [hꗗԂ
	ChkWordList& GetChkWordList();
};

////////////////////////////////////////////////////////////////////////
// uӎṽ_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CThanksDialogProc {
public:
	// RXgN^
	CThanksDialogProc(SettingDialogParam& param);

public:
	// uӎṽ_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
};

////////////////////////////////////////////////////////////////////////
// ݒ_CAO
////////////////////////////////////////////////////////////////////////

class CSettingDialog
{
public:
	// RXgN^
	CSettingDialog(SettingDialogParam& param);

private:
	// BkBsfilWrapper ̐ݒs_CAOvV[W
	static BOOL CALLBACK BkBsfilSettingDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// ̑̐ݒs_CAOvV[W
	static BOOL CALLBACK OtherSettingDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// zCgXg̐ݒs_CAOvV[W
	static BOOL CALLBACK WhiteListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// NG [h̐ݒs_CAOvV[W
	static BOOL CALLBACK NgWordListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// OK [h̐ݒs_CAOvV[W
	static BOOL CALLBACK OkWordListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// uӎṽ_CAOvV[W
	static BOOL CALLBACK ThanksDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

public:
	// \
	int DoModal(HWND hWndParent);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// BkBsfilWrapper ̐ݒs_CAOvV[W̋@\
	CBkBsfilSettingDialogProc m_bkBsfilSettingDialogProc;
	// ̑̐ݒs_CAOvV[W̋@\
	COtherSettingDialogProc m_otherSettingDialogProc;
	// zCgXg̐ݒs_CAOvV[W̋@\
	CWhiteListDialogProc m_whiteListDialogProc;
	// NG [h̐ݒs_CAOvV[W̋@\
	CNgWordListDialogProc m_ngWordListDialogProc;
	// OK [h̐ݒs_CAOvV[W̋@\
	COkWordListDialogProc m_okWordListDialogProc;
	// uӎṽ_CAOvV[W̋@\
	CThanksDialogProc m_thanksDialogProc;

private:
	// g̃CX^X
	static CSettingDialog* s_pThis;
};
